/****************************************************************************/
/* T  vF t@CVXe delete eXgpt@C						*/
/*   F 																*/
/* 쐬F 2005.06.19														*/
/* XVF 2011.09.23														*/
/*              TstDelDir.c ɃX^bNgpʒȂ				*/
/* Copyright    resove														*/
/****************************************************************************/

#include "RfInterface.h"
#include "TraceOut.h"
#include "TstWriteVal.h"
#include "TstDefine.h"
#include "TstGeneral.h"
#include "DebugFunc.h"

#define MANY_NUM				( 5 )

static char * freeSp1;
static char * freeSp2;

static void writeSub( char * flName );
static void writeMany( char * pPath );


/****************************************************************************/
/* T  v																	*/
/*        fBNg폜̃X^bNgpʂ𒲂ׂ							*/
/* p[^																*/
/*        Ȃ																*/
/* ߂l																	*/
/*        Ȃ																*/
/*   																	*/
/****************************************************************************/
void SpChkDelDir( void )
{
	unsigned short err;

	TEST_TITLE(("TEST Delete Directory."));
	TestReady();

	fillSp();
	freeSp1 = checkFreeSp();
	err = RfMkDir( "\\sub1" );
	freeSp2 = checkFreeSp();
	TRACE_OUT(("    Calculate StackSize. RfMkDir 0x%08lx -> 0x%08lx(%ld)\n", freeSp1,
											 freeSp2,
											 (unsigned long)freeSp1 - (unsigned long)freeSp2));
	CHK_ERR_CODE(err, RF_OK, "RfMkDir(\\sub1)");
	err = RfMkDir( "\\sub1\\sub2" );
	CHK_ERR_CODE(err, RF_OK,  "RfMkDir(\\sub2)");
	err = RfMkDir( "\\sub1\\sub2\\sub3" );
	CHK_ERR_CODE(err, RF_OK,  "RfMkDir(\\sub3)");
	err = RfMkDir( "\\sub1\\sub2\\sub3\\sub4" );
	CHK_ERR_CODE(err, RF_OK,  "RfMkDir(\\sub4)");
	err = RfMkDir( "\\sub1\\sub2\\sub3\\sub4\\sub5" );
	CHK_ERR_CODE(err, RF_OK,  "RfMkDir(\\sub5)");


	err = RfMkDir( "\\subb1" );
	CHK_ERR_CODE(err, RF_OK,  "RfMkDir(\\subb1)");
	err = RfMkDir( "\\subb1\\subb2" );
	CHK_ERR_CODE(err, RF_OK,  "RfMkDir(\\subb2)");

	writeSub( "\\sub1\\aaa11.txt" );					/* write(sub1\aaa11.txt) */
	writeSub( "\\sub1\\aaa12.txt" );					/* write(sub1\aaa12.txt) */

	writeSub( "\\sub1\\sub2\\aaa21.txt" );				/* write(sub1\sub2\aaa21.txt) */
	writeSub( "\\sub1\\sub2\\aaa22.txt" );				/* write(sub1\sub2\aaa22.txt) */
	writeSub( "\\sub1\\sub2\\aaa23.txt" );				/* write(sub1\sub2\aaa23.txt) */

	err = RfMkDir( "\\sub1\\sub2\\sub3" );

	writeSub( "\\sub1\\sub2\\sub3\\aaa31.txt" );		/* write(sub1\sub2\sub3\aaa31.txt) */
	writeMany("\\sub1\\sub2\\sub3\\bbb");				/* 񏑂 */

	writeSub( "\\root.txt" );							/* write(root.txt) */

	/* delete dir */
	fillSp();
	freeSp1 = checkFreeSp();
	err = RfDelDir( "\\sub1" );
	freeSp2 = checkFreeSp();
	TRACE_OUT(("    Calculate StackSize. RfDelDir(5 layer) 0x%08lx -> 0x%08lx(%ld)\n", freeSp1,
											 freeSp2,
											 (unsigned long)freeSp1 - (unsigned long)freeSp2));
	CHK_ERR_CODE(err, RF_OK,  "RfDelDir()");

	fillSp();
	freeSp1 = checkFreeSp();
	err = RfDelDir( "\\subb1\\subb2\\" );			/* \ Ōɕt */
	freeSp2 = checkFreeSp();
	TRACE_OUT(("    Calculate StackSize. RfDelDir(1 layer) 0x%08lx -> 0x%08lx(%ld)\n", freeSp1,
											 freeSp2,
											 (unsigned long)freeSp1 - (unsigned long)freeSp2));
	CHK_ERR_CODE(err, RF_OK,  "RfDelDir()");

	err = RfDelDir( "\\" );
	CHK_ERR_CODE(err, RF_ERR_ROOT_DIRECTORY,  "RfDelDir()[NG]");	/* root ͏ȂG[ɂȂ */

	TestConclude( );
}

/****************************************************************************/
/* T  v																	*/
/*        t@C쐬											*/
/* p[^																*/
/*        pPathFt@Ci[ʒũpX										*/
/* ߂l																	*/
/*        Ȃ																*/
/*   																	*/
/****************************************************************************/
void writeMany( char * pPath )
{
	T_RF_FCB * pFcb;
	unsigned short err = RF_OK;
	unsigned long len;
	unsigned short i;
	char flName[32];
	unsigned short nameIx;

	for( i = 0; pPath[i] != '\0'; ++i )
	{
		flName[i] = pPath[i];
	}

	nameIx = i;
	for( i = 0; i < MANY_NUM; ++i )
	{
		numToChar( &flName[nameIx], (unsigned long)i, 1000L);
		pFcb = RfOpen( flName, RF_OPEN_WRITE_NEW, &err );
		if( pFcb )
		{
			len = nameIx + 3;
			err = RfWrite( pFcb, flName, &len);
			err = RfClose( pFcb );
		}
		CHK_ERR_CODE(err, RF_OK, flName);
	}
	
}

/****************************************************************************/
/* T  v																	*/
/*        P̃t@C쐬											*/
/* p[^																*/
/*        flNameFt@C												*/
/* ߂l																	*/
/*        Ȃ																*/
/*   																	*/
/****************************************************************************/
void writeSub( char * flName )
{
	T_RF_FCB * pFcb;
	unsigned short err = RF_OK;
	unsigned long len;									/* eXgΏۂ̃t@CTCY */

	pFcb = RfOpen( flName, RF_OPEN_WRITE_NEW, &err );
	if( pFcb )
	{
		len = 10UL;
		err = RfWrite( pFcb, (char*)constWriteVal, &len );
		CHK_ERR_CODE( err, RF_OK, "RfWrite()" );
		err = RfClose( pFcb );
		CHK_ERR_CODE( err, RF_OK, "RfClose()" );
	}
	CHK_ERR_CODE( err, RF_OK, flName );
}
