/****************************************************************************/
/* T  vF ჌xhCoP̃eXg										*/
/*   F hCo̒P̃eXg											*/
/* 쐬F 2013.7.7														*/
/* XVF 2014.02.02														*/
/* Copyright    resove														*/
/****************************************************************************/

#include "DrvSdDmaSciItu.h"
#include "DebugFunc.h"
#include "TraceOut.h"
#include "TstWriteVal.h"

#include "3048F.H"

/* ֐^錾 */
static void testSendSdOne(void);
static void testBlock(void);


/****************************************************************************/
/* T  v																	*/
/*        ჌xhCoeXg											*/
/* p[^																*/
/*        Ȃ																*/
/* ߂l																	*/
/*        Ȃ																*/
/*   																	*/
/*         																	*/
/****************************************************************************/
void TstOrgLowDriver()
{
	static const T_TEST_MENU testCase[] =
	{
		{'1', "One Byte.", 				testSendSdOne},
		{'2', "Block Transmit.",		testBlock},
		{'q', "quit",			0},

	};

	static const unsigned short testCaseNum = sizeof(testCase)/sizeof(T_TEST_MENU);

	TestMenu(testCase, testCaseNum, "gcc H8 DMA:Low Level Driver test.(Loop Back Test.)");
}

/****************************************************************************/
/* T  v																	*/
/*        PoCgMeXg												*/
/* p[^																*/
/*        Ȃ																*/
/* ߂l																	*/
/*        Ȃ																*/
/*   																	*/
/*         																	*/
/****************************************************************************/
void testSendSdOne( void )
{
	unsigned short err;
	unsigned short recv;

	InitSdTrans( );
	recv = SendSdOne( '\x12' );
	CHK_CMP_HEX(recv, '\x12', "SendSdOne()");
	recv = SendSdOne( '\xef' );
	CHK_CMP_HEX(recv, 0x00ef, "SendSdOne()");


}

/****************************************************************************/
/* T  v																	*/
/*        ubNMAMhCo@\eXg								*/
/* p[^																*/
/*        Ȃ																*/
/* ߂l																	*/
/*        Ȃ																*/
/*   																	*/
/*         																	*/
/****************************************************************************/
void testBlock( void )
{
#	define	TEST_LEN	(512)
	unsigned short err;
	unsigned char buff[TEST_LEN];
	unsigned char recvAns[TEST_LEN];
	unsigned short size = 0;
	T_SD_POLL sdPoll;
	unsigned short ix;


	InitSdTrans( );


	/* M */
	err = SendSdKick( (char*)constWriteVal, TEST_LEN );				/* Af[^̑MN */
	while( (sdPoll = SdDmaPoll( &size )) != SD_POLL_COMPLETE );
	CHK_CMP_DEC(err, 1, "SendSdKick()" );
	CHK_CMP_DEC(size, TEST_LEN, "SendSdKick() length");
	CHK_CMP_DEC(sdPoll, SD_POLL_COMPLETE, "SendSdKick() sdPoll");



	/* M */
	for( ix = 0; ix < TEST_LEN; ix++ )
	{
		buff[ix] = 0;
		recvAns[ix] = 0x55;
	}
	err = RecvSdKick( (char *)buff, 0x55, TEST_LEN  );
	for( ix = 0; ix < 50000; ix++ )
	{
		sdPoll = SdDmaPoll( &size );
		if( sdPoll == SD_POLL_COMPLETE )
		{
			break;
		}
	}
	for( ix = 0; ix < TEST_LEN ; ix++ )
	{
		if( buff[TEST_LEN-ix-1] != recvAns[TEST_LEN-ix-1] )
		{
			CHK_CMP_HEX(buff[TEST_LEN-ix-1], recvAns[TEST_LEN-ix-1], "RecvSdKick");
			TRACE_OUT(("  ix[%d]\n", ix));
			break;
		}
	}
	CHK_CMP_DEC(err, 1, "RecvSdKick()" );
	CHK_CMP_DEC(size, TEST_LEN, "RecvSdKick() length");
	CHK_CMP_DEC(sdPoll, SD_POLL_COMPLETE, "RecvSdKick() sdPoll");


}
