OUTPUT_FORMAT("elf32-h8300")
OUTPUT_ARCH(h8300h)
ENTRY("_Reset")
MEMORY
{
	rom(r)     : o = 0x000000, l = 0x40000
	ram(w)     : o = 0x0fef10, l = 0x01000
}
SECTIONS
{
	.text    : { *(.vect) *(.text)	}	> rom
	.init    : { *(.init)	}		> rom
	.fini    : { *(.fini)	}		> rom
	.rodata  : { *(.rodata) *(.rodata*) }	> rom

	.data    : AT(rom_end)
		   	   { *(.data) } 	> ram	/* 初期値のある変数 */

	/*  0 に初期化するセクション */
	.clear  : {
		*(.bss)					/* 初期値のない変数 */
		*(COMMON)				/* ??? */
		*(.ctors)				/* コンストラクタ */
		*(.dtors)				/* デストラクタ */
		*(.eh_frame)				/* スタックフレーム */
		*(.jcr)					/* java ... */
		*(.tm_clone_table)			/* ??? */
				}	> ram
	.heap    : {	LONG(0); }	> ram

	.stack   0x0fef10+0x1000-4 	/* RAM の最終位置に配置する */
			 : { *(.stack) }	> ram

	/* ラベル定義 */
	rom_end     = ABSOLUTE( ADDR(.rodata)) + SIZEOF(.rodata);	/* .text の終端 */
	__data_init   = ABSOLUTE( LOADADDR(.data));	/* .data の初期値 */
	__data_start  = ABSOLUTE( ADDR(.data));		/* .data の先頭 */
	__data_end    = __data_start + SIZEOF(.data);	/* .data の終端 */
	__bss_start   = ABSOLUTE( ADDR(.clear) );	/* .clear の先頭 */
	__bss_end     = __bss_start + SIZEOF(.clear);	/* .clear の終端 */
	__stack_start = ABSOLUTE( ADDR(.heap) ) + SIZEOF(.heap);	/* .stack の先頭 */

	/* ctr0.s で初期化時に使用している */
	_edata       = __data_end;			/* .data の終端  */
	_end         = __bss_end;			/* .heap の開始(= .clearの終端) */
}

