/****************************************************************************/
/* T  vF wav t@CĐ											*/
/*   F wave t@ČA\AIt@C̍ĐȂB	*/
/*          ܂AmFp sin g̏o͂ȂB							*/
/* 쐬F 2004.09.11														*/
/* XVF 2013.09.26														*/
/* Copyright    resove 														*/
/****************************************************************************/
#include "RfInterface.h"
#include "soundOut.h"

#include "DebugFunc.h"
#include "TraceOut.h"
#include "TstDefine.h"
#include "TstGeneral.h"

typedef unsigned short (T_GET_FUNC)( char * pBuff, unsigned short len );



typedef struct s_wav
{
	char RIFF_Head[4];			/* RIFF wb_ "RIFF" */
	char fileSize[4];			/* RIFF_Head,fileSize t@CTCY */
	char fileDescriptor[4];		/* WAVE wb_ "WAVE" */
} T_WAV_HEADER;

typedef struct s_chunk_info
{
	char ckid[4];					/* tH[}bg` "fmt " */
	char cksize[4];					/* ckid,cksize  T_CHUNK_INFO ̃TCY */

	char wFormatTag[2];				/* tH[}bg^O	*/
	char nChannels[2];				/* `l	*/
	char nSamplesPerSec[4];			/* TvO[g 11025Hz  0x11 0x2b 0x00 0x00 */
	char nAvgBytesPerSec[4];		/* f[^x nSamplesPerSec ~ nBlockAlign */
	char nBlockAlign[2];			/* ubNTCY (nChannels ~ wBitsPerSample) / 8 */
	char wBitsPerSample[2];			/* TvOf[^rbg 8 or 16 */
	
} T_CHUNK_INFO;

static unsigned long waveSize;				/* g`f[^̃TCY				*/
static char * pSin;							/* sin gf[^̃|C^			*/
static unsigned short sinSize;				/* sin g̃TCY					*/
static unsigned short sinIx;				/* o͒ sin g̃CfbNX		*/
static T_RF_FCB *pFcb;						/* Đ wav t@C̎ʎq		*/
static unsigned long beforeTimeSecond;		/* Đ wav t@C̐is	*/
#define WAVE_FILE_LIST_NUM		(20)
#define WAVE_FILE_LEN			(20)
static char waveFileList[WAVE_FILE_LIST_NUM][WAVE_FILE_LEN];	/* wav t@CXg	*/
static unsigned short waveFileListIx = 0;	/* wav t@CXg̃CfbNX	*/

#define	SEARCH_PATH				"\\"

/* wFormatTag ̓e */
#define WAVE_FORMAT_PCM	( 0x0001 )	/* PCM ` */
#define SAMPLING_RATE	( 11025UL )	/* 11,025Hz sample*/

static void PlayMusic( void );
static void PlayWav( char * wavFile );
static unsigned short initWavFile( char * pFile );
static unsigned short checkHeader( T_RF_FCB *pFcb );
static unsigned short checkWavePart( T_RF_FCB *pFcb );
static unsigned short getWavDat( char * pBuff, unsigned short len );
static unsigned long calcWaveTime( unsigned long size );
static void dispProgress( unsigned long current );
static unsigned short getExtention( char * name );
static void searchWav( void );
static unsigned short menuWav( void );

static void PlaySin( void );
static void sin50( void );
static void sin440( void );
static unsigned short getSinDat( char * pBuff, unsigned short len );

static unsigned short makeUShortData( char * pBuff);
static unsigned long makeULongData( char * pBuff);

/****************************************************************************/
/* T  v																	*/
/*        eXgj[̕\As										*/
/* p[^																*/
/*        Ȃ																*/
/* ߂l																	*/
/*        Ȃ																*/
/*   																	*/
/****************************************************************************/
int main(void)
{
	static const char versionTitle[] = "gcc H8:System version. Build(" __DATE__ " " __TIME__ ")";
	static const T_TEST_MENU testCase[] =
	{
		{'1', "play wav file.",		PlayMusic},
		{'2', "out sin wave.",		PlaySin},
		{'q', "quit",										NULL},

	};

	static const unsigned short testCaseNum = (unsigned short)(sizeof(testCase)/sizeof(T_TEST_MENU));

	InitLED();
    TstVersion((char*)versionTitle);					/* o[W\ */
	TestMenu(testCase, testCaseNum, "gcc H8:Play wav file.");

	operationOut("finish!!\n");
	winkLoop();

	return 0;
}

/****************************************************************************/
/* T  v																	*/
/*        "balcony.wav"̓ǂݎ聕Đ										*/
/* p[^																*/
/*        Ȃ																*/
/* ߂l																	*/
/*        Ȃ																*/
/*   																	*/
/*        ȉ̃t@Ĉ݋Ȃ̓G[B							*/
/*        E11,025Hz samplingB												*/
/*        E8 bit															*/
/*        E2ch																*/
/****************************************************************************/
void PlayMusic( void )
{
	unsigned short selectFile;
	unsigned short err;

	err = RfInitFileSystem( );

	if(err != RF_OK )
	{
		CHK_ERR_CODE(err, RF_OK, "RfInitFileSystem()");
	}
	else
	{
		searchWav();					/* wav t@C */
		if( waveFileListIx != 0 )
		{
			selectFile = 0;
			while( selectFile != 0xffff )
			{
				selectFile = menuWav();			/* Ij[\	*/
				if( selectFile != 0xffff )
				{
					/* It@C̍Đ */
					PlayWav(waveFileList[selectFile]);
				}
			}
		}

		RfConclude( );
	}
}

/****************************************************************************/
/* T  v																	*/
/*        wav t@C											*/
/* p[^																*/
/*        Ȃ																*/
/* ߂l																	*/
/*        Ȃ																*/
/*   																	*/
/*        [gfBNg wav t@C waveFileList Ɋi[	*/
/*        B															*/
/****************************************************************************/
void searchWav( void )
{
	T_RF_FCB * pFcb;
	unsigned short err;
	T_RF_DIR_INFO dirInfo;
	unsigned short extPoint;
	int pathLen;

	waveFileListIx = 0;
	pFcb = RfOpenDir( SEARCH_PATH, &err );
	if( pFcb == NULL )
	{
		CHK_ERR_CODE(err, RF_OK, "RfOpenDir()");
	}
	else
	{
		while( waveFileListIx < WAVE_FILE_LIST_NUM )
		{
			err = RfReadDir( pFcb, &dirInfo );
			if( err == RF_ERR_EOF )
			{
				RfCloseDir(pFcb);
				return;
			}
			if( err != RF_OK )
			{
				CHK_ERR_CODE(err, RF_OK, "RfReadDir()");
				break;
			}
			else
			{
				if( (dirInfo.attribute & DIR_ATTR_DIRECTORY) == 0 )
				{
					extPoint = getExtention(dirInfo.name);
					if( extPoint != 0xffff )
					{
						if( ( rfMemCmp("wav", &dirInfo.name[extPoint], 3UL) == 0 ) ||
							( rfMemCmp("WAV", &dirInfo.name[extPoint], 3UL) == 0 ) )
						{
							rfMemCpy(waveFileList[waveFileListIx], SEARCH_PATH, WAVE_FILE_LEN);
							pathLen = rfStrLen(waveFileList[waveFileListIx], WAVE_FILE_LEN);
							rfMemCpy(&waveFileList[waveFileListIx][pathLen], dirInfo.name, WAVE_FILE_LEN - pathLen);
							waveFileListIx++;
						}
					}
				}
			}
		}
		RfCloseDir(pFcb);
	}
}

/****************************************************************************/
/* T  v																	*/
/*        wav t@Cj[\t@CI						*/
/* p[^																*/
/*        Ȃ																*/
/* ߂l																	*/
/*        It@C̃CfbNX									*/
/*   																	*/
/*        waveFileList  wav t@CIj[Ƃĕ\B		*/
/*        IȂꍇ 0xffff ԂB								*/
/****************************************************************************/
unsigned short menuWav( void )
{
	char select;
	unsigned short i;

	operationOut("~~~~ s e l e c t  f i l e . ~~~~\n");

	/* Ij[\ */
	for( i = 0; i < waveFileListIx; i++ )
	{
		if( i < 10 )
		{
			operationOut("%c. %s\n", i + '0', waveFileList[i] );
		}
		else
		{
			operationOut("%c. %s\n", i + 'a' - 10, waveFileList[i] );
		}
	}
	operationOut("q. quit.\n");
	operationOut("==> ");

	/* I */
	select = operationIn();
	operationOut("%c\n", select);
	if( (select >= '0') && (select <= '9') )
	{
		return select - '0';
	}
	if( (select >= 'a') && (select <= ('a' + waveFileListIx)) )
	{
		return select - 'a' + 10;
	}
	else
	{
		return 0xffff;
	}
}

/****************************************************************************/
/* T  v																	*/
/*        t@CgqT												*/
/* p[^																*/
/*        nameFt@C													*/
/* ߂l																	*/
/*        gq̈ʒũCfbNX										*/
/*        Ȃꍇ 0xffff ԂB							*/
/*   																	*/
/****************************************************************************/
unsigned short getExtention( char * name )
{
	unsigned short extPoint = 0xffff;
	unsigned short i;

	for( i = 0; i < 13; i++ )
	{
		if( name[i] == '\0' )
		{
			/* Ȃ */
			break;
		}
		if( name[i] == '.' )
		{
			if( name[i+1] != '\0' )
			{
				/* '.' ̎ɕΊgqʒuƂ */
				extPoint = i+1;
				break;
			}
		}
	}

	return extPoint;
}

/****************************************************************************/
/* T  v																	*/
/*        wav t@C̓ǂݎ聕Đ										*/
/* p[^																*/
/*        wavFt@C̃pX												*/
/* ߂l																	*/
/*        Ȃ																*/
/*   																	*/
/*        ȉ̃t@Ĉ݋Ȃ̓G[B							*/
/*        E11,025Hz samplingB												*/
/*        E8 bit															*/
/*        E2ch																*/
/****************************************************************************/
void PlayWav( char * wavFile )
{
	unsigned short err;
	unsigned long timeSecond;

	if( initWavFile(wavFile) == TRUE )
	{
		/* t@C\ */
		timeSecond = calcWaveTime(waveSize);
		beforeTimeSecond = 0UL;
		operationOut("%s(%02d:%02d)\n",
										wavFile,
										(unsigned short)(timeSecond / 60UL),
										(unsigned short)(timeSecond % 60UL));
		if( startPlay( getWavDat, dispProgress, waveSize ) == TRUE )		/* f[^ĐJn */
		{
			continuePlay( );				/* f[^Đp */
		}

		RfClose(pFcb);
	}

	/* ~ */
	stopPlay();
	operationOut("!\n");

}

/****************************************************************************/
/* T  v																	*/
/*        sin go̓j[\											*/
/* p[^																*/
/*        Ȃ																*/
/* ߂l																	*/
/*        Ȃ																*/
/*   																	*/
/****************************************************************************/
void PlaySin( void )
{
	static const T_TEST_MENU testCase[] =
	{
		{'1', "50Hz.",		sin50},
		{'2', "440Hz.",		sin440},
		{'q', "quit",										NULL},

	};

	static const unsigned short testCaseNum = (unsigned short)(sizeof(testCase)/sizeof(T_TEST_MENU));

	TestMenu(testCase, testCaseNum, "gcc H8:Out sin wave.");

}
/****************************************************************************/
/* T  v																	*/
/*        50Hz sin go													*/
/* p[^																*/
/*        Ȃ																*/
/* ߂l																	*/
/*        Ȃ																*/
/*   																	*/
/****************************************************************************/
void sin50( void )
{
	/* 11,025Hz sampling  50Hz ̃f[^ 2 (441 sample)	*/
	/* E`l	*/
	static const unsigned char freqData[] = 
	{
		128,128,132,132,135,135,139,139,143,143,146,146,150,150,153,153,157,157,160,160,
		164,164,167,167,171,171,174,174,178,178,181,181,184,184,188,188,191,191,194,194,
		197,197,200,200,203,203,206,206,209,209,212,212,214,214,217,217,220,220,222,222,
		225,225,227,227,229,229,231,231,234,234,236,236,237,237,239,239,241,241,243,243,
		244,244,246,246,247,247,248,248,250,250,251,251,252,252,253,253,253,253,254,254,
		255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
		255,255,254,254,254,254,253,253,252,252,251,251,250,250,249,249,247,247,246,246,
		245,245,243,243,241,241,240,240,238,238,236,236,234,234,232,232,230,230,228,228,
		225,225,223,223,220,220,218,218,215,215,212,212,210,210,207,207,204,204,201,201,
		198,198,195,195,192,192,188,188,185,185,182,182,179,179,175,175,172,172,168,168,
		165,165,161,161,158,158,154,154,151,151,147,147,143,143,140,140,136,136,133,133,
		129,129,125,125,122,122,118,118,114,114,111,111,107,107,104,104,100,100, 96, 96,
		 93, 93, 89, 89, 86, 86, 83, 83, 79, 79, 76, 76, 72, 72, 69, 69, 66, 66, 63, 63,
		 60, 60, 57, 57, 54, 54, 51, 51, 48, 48, 45, 45, 42, 42, 40, 40, 37, 37, 34, 34,
		 32, 32, 30, 30, 27, 27, 25, 25, 23, 23, 21, 21, 19, 19, 17, 17, 15, 15, 14, 14,
		 12, 12, 11, 11,  9,  9,  8,  8,  7,  7,  6,  6,  5,  5,  4,  4,  3,  3,  2,  2,
		  1,  1,  1,  1,  1,  1,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  1,  1,
		  1,  1,  2,  2,  2,  2,  3,  3,  4,  4,  5,  5,  6,  6,  7,  7,  8,  8, 10, 10,
		 11, 11, 12, 12, 14, 14, 16, 16, 18, 18, 19, 19, 21, 21, 24, 24, 26, 26, 28, 28,
		 30, 30, 33, 33, 35, 35, 38, 38, 40, 40, 43, 43, 46, 46, 49, 49, 51, 51, 54, 54,
		 57, 57, 60, 60, 64, 64, 67, 67, 70, 70, 73, 73, 77, 77, 80, 80, 83, 83, 87, 87,
		 90, 90, 94, 94, 97, 97,101,101,104,104,108,108,112,112,115,115,119,119,123,123,
		126,126,130,130,133,133,137,137,141,141,144,144,148,148,152,152,155,155,159,159,
		162,162,166,166,169,169,173,173,176,176,179,179,183,183,186,186,189,189,192,192,
		196,196,199,199,202,202,205,205,207,207,210,210,213,213,216,216,218,218,221,221,
		223,223,226,226,228,228,230,230,232,232,235,235,237,237,238,238,240,240,242,242,
		244,244,245,245,246,246,248,248,249,249,250,250,251,251,252,252,253,253,254,254,
		254,254,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
		255,255,255,255,254,254,253,253,252,252,251,251,250,250,249,249,248,248,247,247,
		245,245,244,244,242,242,241,241,239,239,237,237,235,235,233,233,231,231,229,229,
		226,226,224,224,222,222,219,219,216,216,214,214,211,211,208,208,205,205,202,202,
		199,199,196,196,193,193,190,190,187,187,184,184,180,180,177,177,173,173,170,170,
		167,167,163,163,160,160,156,156,152,152,149,149,145,145,142,142,138,138,134,134,
		131,131,127,127,123,123,120,120,116,116,113,113,109,109,105,105,102,102, 98, 98,
		 95, 95, 91, 91, 88, 88, 84, 84, 81, 81, 77, 77, 74, 74, 71, 71, 68, 68, 64, 64,
		 61, 61, 58, 58, 55, 55, 52, 52, 49, 49, 46, 46, 44, 44, 41, 41, 38, 38, 36, 36,
		 33, 33, 31, 31, 28, 28, 26, 26, 24, 24, 22, 22, 20, 20, 18, 18, 16, 16, 15, 15,
		 13, 13, 11, 11, 10, 10,  9,  9,  7,  7,  6,  6,  5,  5,  4,  4,  3,  3,  2,  2,
		  2,  2,  1,  1,  1,  1,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  1,  1,
		  1,  1,  1,  1,  2,  2,  3,  3,  3,  3,  4,  4,  5,  5,  6,  6,  8,  8,  9,  9,
		 10, 10, 12, 12, 13, 13, 15, 15, 17, 17, 19, 19, 20, 20, 22, 22, 25, 25, 27, 27,
		 29, 29, 31, 31, 34, 34, 36, 36, 39, 39, 42, 42, 44, 44, 47, 47, 50, 50, 53, 53,
		 56, 56, 59, 59, 62, 62, 65, 65, 68, 68, 72, 72, 75, 75, 78, 78, 82, 82, 85, 85,
		 89, 89, 92, 92, 96, 96, 99, 99,103,103,106,106,110,110,113,113,117,117,121,121,
		124,124
	};
	static const unsigned short freqNum = sizeof(freqData);		/* f[^TCY		*/


	waveSize = 0xffffffffUL;				/* f܂Ŏ~܂Ȃ */
	pSin = (char*)freqData;
	sinSize = freqNum;
	sinIx = 0;

	if( startPlay( getSinDat, NULL, 0xffffffffUL ) == TRUE )	/* f[^ĐJn */
	{
		continuePlay(  );				/* f[^Đp */
	}
	stopPlay();

}

/****************************************************************************/
/* T  v																	*/
/*        440Hz sin go													*/
/* p[^																*/
/*        Ȃ																*/
/* ߂l																	*/
/*        Ȃ																*/
/*   																	*/
/****************************************************************************/
void sin440( void )
{
	/* 11,025Hz sampling  440Hz ̃f[^ 88 (2205 sample)	*/
	static const unsigned char freqData[] = 
	{
		128,128,160,160,190,190,215,215,236,236,250,250,255,255,254,254,244,244,227,227,
		204,204,176,176,145,145,113,113, 82, 82, 54, 54, 30, 30, 13, 13,  3,  3,  0,  0,
		  6,  6, 19, 19, 39, 39, 65, 65, 94, 94,126,126,158,158,188,188,214,214,235,235,
		249,249,255,255,254,254,245,245,228,228,205,205,178,178,147,147,115,115, 84, 84,
		 55, 55, 31, 31, 14, 14,  3,  3,  0,  0,  5,  5, 18, 18, 38, 38, 63, 63, 93, 93,
		124,124,156,156,186,186,213,213,234,234,248,248,255,255,254,254,246,246,229,229,
		207,207,179,179,149,149,117,117, 85, 85, 57, 57, 33, 33, 14, 14,  3,  3,  0,  0,
		  5,  5, 17, 17, 37, 37, 62, 62, 91, 91,123,123,154,154,185,185,211,211,233,233,
		248,248,255,255,255,255,246,246,230,230,208,208,181,181,150,150,118,118, 87, 87,
		 58, 58, 34, 34, 15, 15,  4,  4,  0,  0,  4,  4, 16, 16, 35, 35, 60, 60, 89, 89,

		121,121,153,153,183,183,210,210,232,232,247,247,255,255,255,255,247,247,232,232,
		210,210,183,183,152,152,120,120, 89, 89, 60, 60, 35, 35, 16, 16,  4,  4,  0,  0,
		  4,  4, 15, 15, 34, 34, 59, 59, 87, 87,119,119,151,151,181,181,209,209,231,231,
		246,246,255,255,255,255,248,248,233,233,211,211,184,184,154,154,122,122, 90, 90,
		 61, 61, 36, 36, 17, 17,  5,  5,  0,  0,  3,  3, 15, 15, 33, 33, 57, 57, 86, 86,
		117,117,149,149,180,180,207,207,230,230,246,246,255,255,255,255,248,248,234,234,
		212,212,186,186,156,156,124,124, 92, 92, 63, 63, 38, 38, 18, 18,  5,  5,  0,  0,
		  3,  3, 14, 14, 32, 32, 56, 56, 84, 84,115,115,147,147,178,178,206,206,229,229,
		245,245,254,254,255,255,249,249,235,235,214,214,187,187,157,157,126,126, 94, 94,
		 64, 64, 39, 39, 19, 19,  6,  6,  0,  0,  3,  3, 13, 13, 30, 30, 54, 54, 82, 82,

		113,113,145,145,176,176,204,204,227,227,244,244,254,254,255,255,249,249,236,236,
		215,215,189,189,159,159,127,127, 96, 96, 66, 66, 40, 40, 20, 20,  6,  6,  0,  0,
		  2,  2, 12, 12, 29, 29, 53, 53, 81, 81,112,112,144,144,175,175,203,203,226,226,
		244,244,254,254,255,255,250,250,237,237,216,216,191,191,161,161,129,129, 97, 97,
		 68, 68, 41, 41, 21, 21,  7,  7,  0,  0,  2,  2, 11, 11, 28, 28, 51, 51, 79, 79,
		110,110,142,142,173,173,201,201,225,225,243,243,253,253,255,255,251,251,238,238,
		218,218,192,192,163,163,131,131, 99, 99, 69, 69, 43, 43, 22, 22,  7,  7,  1,  1,
		  2,  2, 11, 11, 27, 27, 50, 50, 77, 77,108,108,140,140,171,171,200,200,224,224,
		242,242,253,253,255,255,251,251,238,238,219,219,194,194,165,165,133,133,101,101,
		 71, 71, 44, 44, 23, 23,  8,  8,  1,  1,  1,  1, 10, 10, 26, 26, 48, 48, 76, 76,

		106,106,138,138,170,170,198,198,223,223,241,241,252,252,255,255,252,252,239,239,
		220,220,195,195,166,166,135,135,103,103, 72, 72, 46, 46, 24, 24,  9,  9,  1,  1,
		  1,  1,  9,  9, 25, 25, 47, 47, 74, 74,104,104,136,136,168,168,197,197,221,221,
		240,240,252,252,255,255,252,252,240,240,222,222,197,197,168,168,137,137,105,105,
		 74, 74, 47, 47, 25, 25,  9,  9,  1,  1,  1,  1,  9,  9, 24, 24, 45, 45, 72, 72,
		103,103,135,135,166,166,195,195,220,220,239,239,252,252,255,255,252,252,241,241,
		223,223,198,198,170,170,138,138,106,106, 76, 76, 48, 48, 26, 26, 10, 10,  1,  1,
		  1,  1,  8,  8, 23, 23, 44, 44, 71, 71,101,101,133,133,164,164,194,194,219,219,
		238,238,251,251,255,255,253,253,242,242,224,224,200,200,171,171,140,140,108,108,
		 77, 77, 50, 50, 27, 27, 11, 11,  2,  2,  1,  1,  7,  7, 22, 22, 43, 43, 69, 69,

		99, 99,131,131,163,163,192,192,218,218,237,237,250,250,255,255,253,253,243,243,
		225,225,201,201,173,173,142,142,110,110, 79, 79, 51, 51, 28, 28, 11, 11,  2,  2,
		  0,  0,  7,  7, 21, 21, 41, 41, 67, 67, 97, 97,129,129,161,161,190,190,216,216,
		237,237,250,250,255,255,254,254,244,244,226,226,203,203,175,175,144,144,112,112,
		 81, 81, 53, 53, 29, 29, 12, 12,  2,  2,  0,  0,  6,  6, 20, 20, 40, 40, 66, 66,
		96, 96,127,127,159,159,189,189,215,215,236,236,249,249,255,255,254,254,244,244,
		228,228,204,204,177,177,146,146,114,114, 83, 83, 54, 54, 31, 31, 13, 13,  3,  3,
		  0,  0,  6,  6, 19, 19, 39, 39, 64, 64, 94, 94,125,125,157,157,187,187,214,214,
		235,235,249,249,255,255,254,254,245,245,229,229,206,206,178,178,147,147,115,115,
		 84, 84, 56, 56, 32, 32, 14, 14,  3,  3,  0,  0,  5,  5, 18, 18, 37, 37, 63, 63,

		 92, 92,124,124,156,156,186,186,212,212,234,234,248,248,255,255,255,255,246,246,
		230,230,207,207,180,180,149,149,117,117, 86, 86, 57, 57, 33, 33, 15, 15,  3,  3,
		  0,  0,  5,  5, 17, 17, 36, 36, 61, 61, 90, 90,122,122,154,154,184,184,211,211,
		232,232,248,248,255,255,255,255,247,247,231,231,209,209,182,182,151,151,119,119,
		 88, 88, 59, 59, 34, 34, 16, 16,  4,  4,  0,  0,  4,  4, 16, 16, 35, 35, 60, 60,
		 89, 89,120,120,152,152,182,182,209,209,231,231,247,247,255,255,255,255,247,247,
		232,232,210,210,183,183,153,153,121,121, 89, 89, 60, 60, 35, 35, 16, 16,  4,  4,
		  0,  0,  4,  4, 15, 15, 34, 34, 58, 58, 87, 87,118,118,150,150,181,181,208,208,
		230,230,246,246,255,255,255,255,248,248,233,233,212,212,185,185,155,155,123,123,
		 91, 91, 62, 62, 37, 37, 17, 17,  5,  5,  0,  0,  3,  3, 14, 14, 32, 32, 56, 56,

		 85, 85,116,116,148,148,179,179,207,207,229,229,245,245,254,254,255,255,248,248,
		234,234,213,213,186,186,156,156,125,125, 93, 93, 63, 63, 38, 38, 18, 18,  5,  5,
		  0,  0,  3,  3, 13, 13, 31, 31, 55, 55, 83, 83,115,115,147,147,177,177,205,205,
		228,228,245,245,254,254,255,255,249,249,235,235,214,214,188,188,158,158,126,126,
		 95, 95, 65, 65, 39, 39, 19, 19,  6,  6,  0,  0,  2,  2, 13, 13, 30, 30, 54, 54,
		 82, 82,113,113,145,145,176,176,204,204,227,227,244,244,254,254,255,255,250,250,
		236,236,216,216,190,190,160,160,128,128, 96, 96, 67, 67, 41, 41, 20, 20,  6,  6,
		  0,  0,  2,  2, 12, 12, 29, 29, 52, 52, 80, 80,111,111,143,143,174,174,202,202,
		226,226,243,243,253,253,255,255,250,250,237,237,217,217,191,191,162,162,130,130,
		 98, 98, 68, 68, 42, 42, 21, 21,  7,  7,  0,  0,  2,  2, 11, 11, 28, 28, 51, 51,

		 78, 78,109,109,141,141,172,172,201,201,225,225,242,242,253,253,255,255,251,251,
		238,238,218,218,193,193,163,163,132,132,100,100, 70, 70, 43, 43, 22, 22,  8,  8,
		  1,  1,  2,  2, 10, 10, 27, 27, 49, 49, 77, 77,107,107,139,139,171,171,199,199,
		223,223,242,242,253,253,255,255,251,251,239,239,220,220,194,194,165,165,134,134,
		102,102, 71, 71, 45, 45, 23, 23,  8,  8,  1,  1,  1,  1, 10, 10, 25, 25, 48, 48,
		 75, 75,106,106,137,137,169,169,198,198,222,222,241,241,252,252,255,255,252,252,
		240,240,221,221,196,196,167,167,135,135,104,104, 73, 73, 46, 46, 24, 24,  9,  9,
		  1,  1,  1,  1,  9,  9, 24, 24, 46, 46, 73, 73,104,104,136,136,167,167,196,196,
		221,221,240,240,252,252,255,255,252,252,241,241,222,222,198,198,169,169,137,137,
		105,105, 75, 75, 48, 48, 25, 25, 10, 10,  1,  1,  1,  1,  8,  8, 23, 23, 45, 45,

		 72, 72,102,102,134,134,165,165,195,195,220,220,239,239,251,251,255,255,253,253,
		241,241,223,223,199,199,170,170,139,139,107,107, 76, 76, 49, 49, 26, 26, 10, 10,
		  1,  1,  1,  1,  8,  8, 22, 22, 44, 44, 70, 70,100,100,132,132,164,164,193,193,
		218,218,238,238,251,251,255,255,253,253,242,242,224,224,201,201,172,172,141,141,
		109,109, 78, 78, 50, 50, 28, 28, 11, 11,  2,  2,  0,  0,  7,  7, 21, 21, 42, 42,
		 68, 68, 98, 98,130,130,162,162,191,191,217,217,237,237,250,250,255,255,253,253,
		243,243,226,226,202,202,174,174,143,143,111,111, 80, 80, 52, 52, 29, 29, 12, 12,
		  2,  2,  0,  0,  6,  6, 20, 20, 41, 41, 67, 67, 97, 97,128,128,160,160,190,190,
		216,216,236,236,250,250,255,255,254,254,244,244,227,227,204,204,176,176,145,145,
		113,113, 81, 81, 53, 53, 30, 30, 13, 13,  2,  2,  0,  0,  6,  6, 19, 19, 39, 39,

		 65, 65, 95, 95,127,127,158,158,188,188,214,214,235,235,249,249,255,255,254,254,
		245,245,228,228,205,205,177,177,146,146,114,114, 83, 83, 55, 55, 31, 31, 13, 13,
		  3,  3,  0,  0,  5,  5, 18, 18, 38, 38, 64, 64, 93, 93,125,125,157,157,187,187,
		213,213,234,234,249,249,255,255,254,254,245,245,229,229,206,206,179,179,148,148,
		116,116, 85, 85, 56, 56, 32, 32, 14, 14,  3,  3,  0,  0,  5,  5, 17, 17, 37, 37,
		 62, 62, 91, 91,123,123,155,155,185,185,212,212,233,233,248,248,255,255,255,255,
		246,246,230,230,208,208,181,181,150,150,118,118, 87, 87, 58, 58, 33, 33, 15, 15,
		  4,  4,  0,  0,  4,  4, 17, 17, 36, 36, 60, 60, 90, 90,121,121,153,153,183,183,
		210,210,232,232,247,247,255,255,255,255,247,247,231,231,209,209,182,182,152,152,
		120,120, 88, 88, 59, 59, 35, 35, 16, 16,  4,  4,  0,  0,  4,  4, 16, 16, 34, 34,

		 59, 59, 88, 88,119,119,151,151,182,182,209,209,231,231,247,247,255,255,255,255,
		247,247,232,232,211,211,184,184,154,154,122,122, 90, 90, 61, 61, 36, 36, 17, 17,
		  5,  5,  0,  0,  3,  3, 15, 15, 33, 33, 57, 57, 86, 86,117,117,149,149,180,180,
		207,207,230,230,246,246,255,255,255,255,248,248,233,233,212,212,186,186,155,155,
		123,123, 92, 92, 63, 63, 37, 37, 18, 18,  5,  5,  0,  0,  3,  3, 14, 14, 32, 32,
		 56, 56, 84, 84,116,116,148,148,178,178,206,206,229,229,245,245,254,254,255,255,
		249,249,234,234,213,213,187,187,157,157,125,125, 94, 94, 64, 64, 39, 39, 19, 19,
		  6,  6,  0,  0,  3,  3, 13, 13, 31, 31, 54, 54, 83, 83,114,114,146,146,177,177,
		205,205,228,228,244,244,254,254,255,255,249,249,235,235,215,215,189,189,159,159,
		127,127, 95, 95, 66, 66, 40, 40, 20, 20,  6,  6,  0,  0,  2,  2, 12, 12, 30, 30,

		 53, 53, 81, 81,112,112,144,144,175,175,203,203,226,226,244,244,254,254,255,255,
		250,250,236,236,216,216,190,190,161,161,129,129, 97, 97, 67, 67, 41, 41, 21, 21,
		  7,  7,  0,  0,  2,  2, 12, 12, 28, 28, 51, 51, 79, 79,110,110,142,142,173,173,
		202,202,225,225,243,243,253,253,255,255,250,250,237,237,217,217,192,192,162,162,
		131,131, 99, 99, 69, 69, 43, 43, 22, 22,  7,  7,  0,  0,  2,  2, 11, 11, 27, 27,
		 50, 50, 78, 78,108,108,140,140,172,172,200,200,224,224,242,242,253,253,255,255,
		251,251,238,238,219,219,193,193,164,164,133,133,101,101, 70, 70, 44, 44, 23, 23,
		  8,  8,  1,  1,  1,  1, 10, 10, 26, 26, 49, 49, 76, 76,107,107,139,139,170,170,
		199,199,223,223,241,241,253,253,255,255,251,251,239,239,220,220,195,195,166,166,
		134,134,102,102, 72, 72, 45, 45, 24, 24,  9,  9,  1,  1,  1,  1,  9,  9, 25, 25,

		 47, 47, 74, 74,105,105,137,137,168,168,197,197,222,222,240,240,252,252,255,255,
		252,252,240,240,221,221,197,197,168,168,136,136,104,104, 74, 74, 47, 47, 25, 25,
		  9,  9,  1,  1,  1,  1,  9,  9, 24, 24, 46, 46, 73, 73,103,103,135,135,166,166,
		196,196,220,220,239,239,252,252,255,255,252,252,241,241,223,223,198,198,169,169,
		138,138,106,106, 75, 75, 48, 48, 26, 26, 10, 10,  1,  1,  1,  1,  8,  8, 23, 23,
		 44, 44, 71, 71,101,101,133,133,165,165,194,194,219,219,239,239,251,251,255,255,
		253,253,242,242,224,224,200,200,171,171,140,140,108,108, 77, 77, 50, 50, 27, 27,
		 11, 11,  2,  2,  1,  1,  7,  7, 22, 22, 43, 43, 69, 69, 99, 99,131,131,163,163,
		192,192,218,218,238,238,251,251,255,255,253,253,243,243,225,225,201,201,173,173,
		142,142,110,110, 79, 79, 51, 51, 28, 28, 11, 11,  2,  2,  0,  0,  7,  7, 21, 21,

		 42, 42, 68, 68, 98, 98,129,129,161,161,191,191,217,217,237,237,250,250,255,255,
		254,254,243,243,226,226,203,203,175,175,143,143,111,111, 80, 80, 52, 52, 29, 29,
		 12, 12,  2,  2,  0,  0,  6,  6, 20, 20, 40, 40, 66, 66, 96, 96,128,128,159,159,
		189,189,215,215,236,236,250,250,255,255,254,254,244,244,227,227,204,204,176,176,
		145,145,113,113, 82, 82, 54, 54, 30, 30, 13, 13,  3,  3,  0,  0,  6,  6, 19, 19,
		 39, 39, 65, 65, 94, 94,126,126,158,158,188,188,214,214,235,235,249,249,255,255,
		254,254,245,245,228,228,206,206,178,178,147,147,115,115, 84, 84, 55, 55, 32, 32,
		 14, 14,  3,  3,  0,  0,  5,  5, 18, 18, 38, 38, 63, 63, 92, 92,124,124,156,156,
		186,186,212,212,234,234,248,248,255,255,255,255,246,246,230,230,207,207,180,180,
		149,149,117,117, 86, 86, 57, 57, 33, 33, 15, 15,  3,  3,  0,  0,  5,  5, 17, 17,

		 36, 36, 61, 61, 91, 91,122,122,154,154,184,184,211,211,233,233,248,248,255,255,
		255,255,246,246,231,231,208,208,181,181,151,151,119,119, 87, 87, 58, 58, 34, 34,
		 15, 15,  4,  4,  0,  0,  4,  4, 16, 16, 35, 35, 60, 60, 89, 89,120,120,152,152,
		183,183,210,210,232,232,247,247,255,255,255,255,247,247,232,232,210,210,183,183,
		152,152,121,121, 89, 89, 60, 60, 35, 35, 16, 16,  4,  4,  0,  0,  4,  4, 15, 15,
		 34, 34, 58, 58, 87, 87,119,119,150,150,181,181,208,208,231,231,246,246,255,255,
		255,255,248,248,233,233,211,211,185,185,154,154,122,122, 91, 91, 62, 62, 36, 36,
		 17, 17,  5,  5,  0,  0,  3,  3, 14, 14, 33, 33, 57, 57, 85, 85,117,117,149,149,
		179,179,207,207,229,229,246,246,254,254,255,255,248,248,234,234,213,213,186,186,
		156,156,124,124, 93, 93, 63, 63, 38, 38, 18, 18,  5,  5,  0,  0,  3,  3, 14, 14,

		 31, 31, 55, 55, 84, 84,115,115,147,147,178,178,205,205,228,228,245,245,254,254,
		255,255,249,249,235,235,214,214,188,188,158,158,126,126, 94, 94, 65, 65, 39, 39,
		 19, 19,  6,  6,  0,  0,  3,  3, 13, 13, 30, 30, 54, 54, 82, 82,113,113,145,145,
		176,176,204,204,227,227,244,244,254,254,255,255,250,250,236,236,215,215,189,189,
		160,160,128,128, 96, 96, 66, 66, 40, 40, 20, 20,  6,  6,  0,  0,  2,  2, 12, 12,
		 29, 29, 52, 52, 80, 80,111,111,143,143,174,174,202,202,226,226,243,243,254,254,
		255,255,250,250,237,237,217,217,191,191,161,161,130,130, 98, 98, 68, 68, 42, 42,
		 21, 21,  7,  7,  0,  0,  2,  2, 11, 11, 28, 28, 51, 51, 79, 79,109,109,141,141,
		173,173,201,201,225,225,243,243,253,253,255,255,251,251,238,238,218,218,193,193,
		163,163,131,131,100,100, 70, 70, 43, 43, 22, 22,  8,  8,  1,  1,  2,  2, 11, 11,

		 27, 27, 49, 49, 77, 77,108,108,140,140,171,171,200,200,224,224,242,242,253,253,
		255,255,251,251,239,239,219,219,194,194,165,165,133,133,101,101, 71, 71, 44, 44,
		 23, 23,  8,  8,  1,  1,  1,  1, 10, 10, 26, 26, 48, 48, 75, 75,106,106,138,138,
		169,169,198,198,222,222,241,241,252,252,255,255,252,252,240,240,221,221,196,196,
		167,167,135,135,103,103, 73, 73, 46, 46, 24, 24,  9,  9,  1,  1,  1,  1,  9,  9,
		 25, 25, 47, 47, 74, 74,104,104,136,136,167,167,196,196,221,221,240,240,252,252,
		255,255,252,252,240,240,222,222,197,197,168,168,137,137,105,105, 74, 74, 47, 47,
		 25, 25,  9,  9,  1,  1,  1,  1,  8,  8, 24, 24, 45, 45, 72, 72,102,102,134,134,
		166,166,195,195,220,220,239,239,251,251,255,255,253,253,241,241,223,223,199,199,
		170,170,139,139,107,107, 76, 76, 49, 49, 26, 26, 10, 10,  1,  1,  1,  1,  8,  8,

		 22, 22, 44, 44, 70, 70,100,100,132,132,164,164,193,193,219,219,238,238,251,251,
		255,255,253,253,242,242,224,224,200,200,172,172,141,141,109,109, 78, 78, 50, 50,
		 27, 27, 11, 11,  2,  2,  0,  0,  7,  7, 21, 21, 42, 42, 69, 69, 99, 99,131,131,
		162,162,192,192,217,217,237,237,250,250,255,255,253,253,243,243,225,225,202,202,
		173,173,142,142,110,110, 79, 79, 52, 52, 28, 28, 12, 12,  2,  2,  0,  0,  7,  7,
		 20, 20, 41, 41, 67, 67, 97, 97,129,129,160,160,190,190,216,216,236,236,250,250,
		255,255,254,254,244,244,227,227,203,203,175,175,144,144,112,112, 81, 81, 53, 53,
		 30, 30, 12, 12,  2,  2,  0,  0,  6,  6, 19, 19, 40, 40, 66, 66, 95, 95,127,127,
		159,159,189,189,215,215,235,235,249,249,255,255,254,254,245,245,228,228,205,205,
		177,177,146,146,114,114, 83, 83, 55, 55, 31, 31, 13, 13,  3,  3,  0,  0,  6,  6,

		 19, 19, 38, 38, 64, 64, 93, 93,125,125,157,157,187,187,213,213,234,234,249,249,
		255,255,254,254,245,245,229,229,206,206,179,179,148,148,116,116, 85, 85, 56, 56,
		 32, 32, 14, 14,  3,  3,  0,  0,  5,  5, 18, 18, 37, 37, 62, 62, 92, 92,123,123,
		155,155,185,185,212,212,233,233,248,248,255,255,255,255,246,246,230,230,208,208,
		180,180,150,150,118,118, 86, 86, 58, 58, 33, 33, 15, 15,  4,  4,  0,  0,  4,  4,
		 17, 17, 36, 36, 61, 61, 90, 90,121,121,153,153,184,184,211,211,232,232,247,247,
		255,255,255,255,247,247,231,231,209,209,182,182,151,151,119,119, 88, 88, 59, 59,
		 34, 34, 16, 16,  4,  4,  0,  0,  4,  4, 16, 16, 35, 35, 59, 59, 88, 88,120,120,
		152,152,182,182,209,209,231,231,247,247,255,255,255,255,247,247,232,232,210,210,
		184,184,153,153,121,121, 90, 90, 61, 61, 36, 36, 17, 17,  4,  4,  0,  0,  4,  4,

		 15, 15, 33, 33, 58, 58, 86, 86,118,118,150,150,180,180,208,208,230,230,246,246,
		255,255,255,255,248,248,233,233,212,212,185,185,155,155,123,123, 91, 91, 62, 62,
		 37, 37, 18, 18,  5,  5,  0,  0,  3,  3, 14, 14, 32, 32, 56, 56, 85, 85,116,116,
		148,148,179,179,206,206,229,229,245,245,254,254,255,255,249,249,234,234,213,213,
		187,187,157,157,125,125, 93, 93, 64, 64, 38, 38, 18, 18,  5,  5,  0,  0,  3,  3,
		 13, 13, 31, 31, 55, 55, 83, 83,114,114,146,146,177,177,205,205,228,228,245,245,
		254,254,255,255,249,249,235,235,215,215,188,188,159,159,127,127, 95, 95, 65, 65,
		 40, 40, 19, 19,  6,  6,  0,  0,  2,  2, 12, 12, 30, 30, 53, 53, 81, 81,112,112,
		144,144,175,175,203,203,227,227,244,244,254,254,255,255,250,250,236,236,216,216,
		190,190,160,160,129,129, 97, 97, 67, 67, 41, 41, 20, 20,  7,  7,  0,  0,  2,  2,

		 12, 12, 29, 29, 52, 52, 80, 80,111,111,143,143,174,174,202,202,226,226,243,243,
		253,253,255,255,250,250,237,237,217,217,192,192,162,162,130,130, 99, 99, 69, 69,
		 42, 42, 21, 21,  7,  7,  0,  0,  2,  2, 11, 11, 27, 27, 50, 50, 78, 78,109,109,
		141,141,172,172,200,200,224,224,242,242,253,253,255,255,251,251,238,238,218,218,
		193,193,164,164,132,132,100,100, 70, 70, 44, 44, 22, 22,  8,  8,  1,  1,  1,  1,
		 10, 10, 26, 26, 49, 49, 76, 76,107,107,139,139,170,170,199,199,223,223,241,241,
		253,253,255,255,251,251,239,239,220,220,195,195,166,166,134,134,102,102, 72, 72,
		 45, 45, 23, 23,  8,  8,  1,  1,  1,  1, 10, 10, 25, 25, 47, 47, 75, 75,105,105,
		137,137,169,169,197,197,222,222,241,241,252,252,255,255,252,252,240,240,221,221,
		196,196,167,167,136,136,104,104, 73, 73, 46, 46, 24, 24,  9,  9,  1,  1,  1,  1,

		  9,  9, 24, 24, 46, 46, 73, 73,103,103,135,135,167,167,196,196,221,221,240,240,
		252,252,255,255,252,252,241,241,222,222,198,198,169,169,138,138,106,106, 75, 75,
		 48, 48, 26, 26, 10, 10,  1,  1,  1,  1,  8,  8, 23, 23, 45, 45, 71, 71,102,102,
		133,133,165,165,194,194,219,219,239,239,251,251,255,255,253,253,242,242,223,223,
		199,199,171,171,139,139,107,107, 77, 77, 49, 49, 27, 27, 10, 10,  2,  2,  1,  1,
		  8,  8, 22, 22, 43, 43, 70, 70,100,100,132,132,163,163,193,193,218,218,238,238,
		251,251,255,255,253,253,242,242,225,225,201,201,172,172,141,141,109,109, 78, 78,
		 51, 51, 28, 28, 11, 11,  2,  2,  0,  0,  7,  7, 21, 21, 42, 42, 68, 68, 98, 98,
		130,130,162,162,191,191,217,217,237,237,250,250,255,255,253,253,243,243,226,226,
		202,202,174,174,143,143,111,111, 80, 80, 52, 52, 29, 29, 12, 12,  2,  2,  0,  0,

		  6,  6,  20,  20,  41,  41, 66, 66, 96, 96
	};
	static const unsigned short freqNum = sizeof(freqData)/sizeof(unsigned long);	/* f[^TCY		*/


	waveSize = 0xffffffffUL;				/* f܂Ŏ~܂Ȃ */
	pSin = (char*)freqData;
	sinSize = freqNum;
	sinIx = 0;

	if( startPlay( getSinDat, NULL, 0xffffffffUL ) == TRUE )	/* f[^ĐJn */
	{
		continuePlay(  );				/* f[^Đp */
	}
	stopPlay();
}

/****************************************************************************/
/* T  v																	*/
/*        wav t@C̓ǂݎAf[^̏							*/
/* p[^																*/
/*        pFile:t@C													*/
/* ߂l																	*/
/*        TRUE:AFALSE:s												*/
/*   																	*/
/****************************************************************************/
unsigned short initWavFile( char * pFile )
{
	unsigned short err;

	pFcb = RfOpen( pFile, RF_OPEN_READ|RF_OPEN_OPT_SEQ, &err);
	if( err != RF_OK )
	{
		CHK_ERR_CODE(err, RF_OK, "RfOpen()");
		return FALSE;
	}
	else if( pFcb == NULL )
	{
		operationOut("Fail RfOpen()\n");
		return FALSE;
	}
	else if( checkHeader( pFcb ) == FALSE )		/* wb_`FbN */
	{
		return FALSE;
	}
	else if( checkWavePart( pFcb ) == FALSE )	/* f[^`FbN */
	{
		return FALSE;
	}

	return TRUE;

}

/****************************************************************************/
/* T  v																	*/
/*        wav t@C̃wb_`FbN								*/
/* p[^																*/
/*        pFcbFt@Cʎq												*/
/* ߂l																	*/
/*        TRUEFAFALSEFs											*/
/*   																	*/
/*        ȉ̃t@Ĉ݋Ȃ̓G[B							*/
/*        E11,025Hz samplingB												*/
/*        E8 bit															*/
/*        E2ch																*/
/****************************************************************************/
unsigned short checkHeader( T_RF_FCB *pFcb )
{
	unsigned long takeLen;
	unsigned short err;
	T_CHUNK_INFO chunkInfo;
	T_WAV_HEADER wavHeader;

	takeLen = (unsigned long)sizeof(wavHeader);
	err = RfRead(pFcb, (char*)&wavHeader, &takeLen);

	if( err != RF_OK )
	{
		CHK_ERR_CODE(err, RF_OK, "RfRead(1)");
		return FALSE;
	}
	if( takeLen != (unsigned long)sizeof(wavHeader) )
	{
		operationOut("Read Fail(5).\n");
		return FALSE;
	}
	if( rfMemCmp( "RIFF", wavHeader.RIFF_Head, 4UL) != 0 )
	{
		operationOut("File Type Not \"TIFF\".\n");
		return FALSE;
	}
	if( makeULongData(wavHeader.fileSize) <= (unsigned long)(sizeof(T_CHUNK_INFO) +  4) )
	{
		operationOut("File size small.\n");
		return FALSE;
	}
	if( rfMemCmp( "WAVE", wavHeader.fileDescriptor, 4UL) != 0 )
	{
		operationOut("File deskliptor not \"WAVE\".\n");
		return FALSE;
	}

	takeLen = (unsigned long)sizeof(chunkInfo);
	err = RfRead(pFcb, (char*)&chunkInfo, &takeLen);
	if( err != RF_OK )
	{
		CHK_ERR_CODE(err, RF_OK, "RfRead(3)");
		return FALSE;
	}
	if( takeLen != (unsigned long)sizeof(chunkInfo) )
	{
		operationOut("Read Fail(5).\n");
		return FALSE;
	}
	if( rfMemCmp( "fmt ", chunkInfo.ckid, 4UL) != 0 )
	{
		operationOut("Format ID unmatch. Not \"fmt \".\n");
		return FALSE;
	}
	if( makeUShortData(chunkInfo.wFormatTag) != WAVE_FORMAT_PCM )
	{
		operationOut("Could not corresponds this formatTag.\n");
	}
	if( makeULongData(chunkInfo.cksize) != ( sizeof(chunkInfo) - 8 ) )
	{
		operationOut("Could not corresponds this chunk size.\n");
		return FALSE;
	}
	if( makeUShortData( chunkInfo.nChannels ) != 2 )
	{
		operationOut("Not stereo.\n");
		return FALSE;
	}
	if( makeULongData( chunkInfo.nSamplesPerSec ) != SAMPLING_RATE )
	{
		operationOut("Sampling rate not corresponds. Not %dHz.\n", SAMPLING_RATE);
		return FALSE;
	}

	return TRUE;
}

/****************************************************************************/
/* T  v																	*/
/*        SIN gf[^ԂɎ擾										*/
/* p[^																*/
/*        pBuffFg`f[^i[̈									*/
/*        len  F擾f[^											*/
/* ߂l																	*/
/*        ۂɎ擾f[^											*/
/*   																	*/
/****************************************************************************/
unsigned short getSinDat( char * pBuff, unsigned short len )
{
	unsigned short i;
	char * pSinWave = &pSin[sinIx];
	for( i = 0; i < len; i++ )
	{
		*pBuff = *pSinWave;			/* f[^] */

		/* CfbNXXV */
		pBuff++;
		pSinWave++;
		sinIx++;
		if( sinSize <= sinIx )
		{
			pSinWave = pSin;		/* obt@܂Ԃ */
			sinIx = 0;
		}
	}

	return len;
}

/****************************************************************************/
/* T  v																	*/
/*        wav t@C̃f[^ԂɎ擾								*/
/* p[^																*/
/*        pBuffFg`f[^i[̈									*/
/*        len  F擾f[^											*/
/* ߂l																	*/
/*        ۂɎ擾f[^											*/
/*   																	*/
/****************************************************************************/
unsigned short getWavDat( char * pBuff, unsigned short len )
{
	unsigned long wishLen;
	unsigned long takeLen;
	unsigned short err;

	wishLen = (unsigned long)len;
	takeLen = (unsigned long)len;

	err = RfRead(pFcb, pBuff, &takeLen);	/* obt@OɊi[ */
	if( err != RF_OK )
	{
		CHK_ERR_CODE(err, RF_OK, "getWavDat() 1.\n");
		return 0;
	}
	if( takeLen != wishLen )
	{
		operationOut("getWavDat() 2.\n");
		return 0;
	}

	return (unsigned short)takeLen;

}

/****************************************************************************/
/* T  v																	*/
/*        f[^̃`FbNĐN										*/
/* p[^																*/
/*        pFcbFt@Cʎq												*/
/* ߂l																	*/
/*        TRUEFAFALSEFs											*/
/*   																	*/
/*        wav t@C̃f[^`FbNB							*/
/*        yt@C̍ĐNB									*/
/****************************************************************************/
unsigned short checkWavePart( T_RF_FCB *pFcb )
{
	unsigned long takeLen;
	unsigned short err;
	char tempBuff[4];
	
	takeLen = 4UL;
	err = RfRead(pFcb, tempBuff, &takeLen);
	if( err != RF_OK )
	{
		CHK_ERR_CODE(err, RF_OK, "RfRead(4)");
		return FALSE;
	}
	if( takeLen != 4UL )
	{
		operationOut("Read Fail(5).\n");
		return FALSE;
	}
	if( rfMemCmp( "data", tempBuff, 4UL) != 0 )
	{
		operationOut("Bloken file\n");
		return FALSE;
	}

	/* f[^TCY擾 */
	takeLen = 4UL;
	err = RfRead(pFcb, tempBuff, &takeLen);
	if( err != RF_OK )
	{
		CHK_ERR_CODE(err, RF_OK, "RfRead(6)");
		return FALSE;
	}
	if( takeLen != 4UL )
	{
		operationOut("Read Fail(7).\n");
		return FALSE;
	}

	waveSize = makeULongData( tempBuff );
	if( waveSize == 0UL )
	{
		operationOut("Empty.\n");
		return FALSE;
	}

	return TRUE;
}


/****************************************************************************/
/* T  v																	*/
/*        Đ̐i\												*/
/* p[^																*/
/*        currentFĐ̃oCgʒu										*/
/* ߂l																	*/
/*        Ȃ																*/
/*   																	*/
/*        b̒Pʂωۂɕ\B									*/
/****************************************************************************/
void dispProgress( unsigned long current )
{
	unsigned long timeSecond;

	timeSecond = calcWaveTime(current);
	if( beforeTimeSecond != timeSecond )
	{
		operationOut("\r%02d:%02d", (unsigned short)(timeSecond / 60UL),
									(unsigned short)(timeSecond % 60UL));
		beforeTimeSecond = timeSecond;
	}
}

/****************************************************************************/
/* T  v																	*/
/*        SoCg̐f[^gݗĂ									*/
/* p[^																*/
/*        pBuffFSoCgf[^i[Ă̈						*/
/* ߂l																	*/
/*        ɕϊl													*/
/*   																	*/
/*        ʃoCgʌɂB										*/
/****************************************************************************/
unsigned long makeULongData( char * pBuff)
{
	return
			(((unsigned long)pBuff[3] <<  (8UL*3UL)) & 0xff000000 ) |
			(((unsigned long)pBuff[2] <<  (8UL*2UL)) & 0x00ff0000 ) |
			(((unsigned long)pBuff[1] <<  (8UL*1UL)) & 0x0000ff00 ) |
			(((unsigned long)pBuff[0] <<  (8UL*0UL)) & 0x000000ff );
}

/****************************************************************************/
/* T  v																	*/
/*        QoCg̐f[^gݗĂ									*/
/* p[^																*/
/*        pBuffFQoCgf[^i[Ă̈						*/
/* ߂l																	*/
/*        ɕϊl													*/
/*   																	*/
/*        ʃoCgʌɂB										*/
/****************************************************************************/
unsigned short makeUShortData( char * pBuff)
{
	return  (unsigned short)(
			(((unsigned short)pBuff[1] <<  (8*1)) & 0xff00 ) |
			(((unsigned short)pBuff[0] <<  (8*0)) & 0x00ff ) );
}

/****************************************************************************/
/* T  v																	*/
/*        g`t@C̍ĐԂvZ									*/
/* p[^																*/
/*        sizeFg`f[^̃TCY											*/
/* ߂l																	*/
/*        																*/
/*   																	*/
/*        TvO玞ԂbŌvZB							*/
/*        11,025Hz XeI(2ch)A\ 8bit ŒŌvZB				*/
/****************************************************************************/
unsigned long calcWaveTime( unsigned long size )
{
	return size / (SAMPLING_RATE * 2UL);
}

/****************************************************************************/
/* T  v																	*/
/*        `荞													*/
/* p[^																*/
/*        Ȃ																*/
/* ߂l																	*/
/*        Ȃ																*/
/*   																	*/
/*        `荞ݔoB									*/
/****************************************************************************/
void dummyLoop( void )
{
	operationOut("dummyLoop\n");
	while(1);
}
